// Copyright (c) 2022 NetEase, Inc. All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.

library netease_roomkit_interface;

export 'src/types/roomkit_options.dart';
export 'src/platform_interface/roomkit_platform.dart';
export 'src/platform_interface/auth_service_platform.dart';
export 'src/platform_interface/room_service_platform.dart';
export 'src/platform_interface/room_chat_controller_platform.dart';
export 'src/types/auth_service_models.dart';
export 'src/platform_interface/room_rtc_controller_platform.dart';
export 'src/platform_interface/preview_room_rtc_controller_platform.dart';
export 'src/platform_interface/room_rtc_render_platform.dart';
export 'src/platform_interface/room_whiteboard_controller_platform.dart';
export 'src/platform_interface/room_seat_controller_platform.dart';
export 'src/platform_interface/room_rtc_stats_platform.dart';

export 'src/types/room_service_models.dart';

export 'src/platform_interface/room_context_platform.dart';
export 'src/platform_interface/message_service_platform.dart';
export 'src/platform_interface/room_live_controller_platform.dart';
export 'src/types/room_live_models.dart';
export 'src/types/rtc_models.dart';
export 'src/types/chatroom_models.dart';
export 'src/types/server_configs.dart';
export 'src/types/seat_models.dart';
export 'package:netease_roomkit_interface/src/types/rtc_models.dart'
    show NEEncryptionMode;
export 'src/types/waiting_room.dart';
export 'src/platform_interface/room_waiting_room_controller_platform.dart';

export 'src/pigeon.dart'
    show
        RoomSnapshot,
        RoomMember,
        RoomRole,
        RoleParams,
        RoleAudioParams,
        RoleVideoParams,
        RoleScreenParams,
        MembersEvent,
        PropertyEvent,
        CommonEvent,
        SeatItem,
        MemberRoleChangeEvent,
        MemberToggleEvent,
        RoomMessage,
        RoomMessageAttachment,
        RoomMessageEvent,
        WhiteboardShowFileChooserTypeEvent,
        RoomEventSink,
        SeatEventSink,
        PreviewRoomEventSink,
        PassThroughMessageEvent,
        RoomToggleEvent,
        RtcVolumeEvent,
        RtcVirtualBackgroundSourceEvent,
        MessageEventSink,
        CreateAudioEffectOption,
        CreateAudioMixingOption,
        LocalVolumeEvent,
        NERoomVirtualBackgroundSource,
        RoomStatsEvent,
        RoomNetworkQuality,
        RoomStatsSink,
        WaitingRoomMember,
        WaitingRoomEventSink,
        WaitingRoomInfo,
        RoomEventType,
        ChatroomType,
        MemberAudioConnectStateChangedEvent,
        MemberNameChangeEvent;
