// Copyright (c) 2022 NetEase, Inc. All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.

import 'package:netease_common/netease_common.dart';
import 'package:netease_roomkit_interface/netease_roomkit_interface.dart';
import 'package:netease_roomkit_interface/src/pigeon.dart';

class MethodChannelRoomRtcRender extends RoomRtcRenderPlatform {
  final _api = RoomRtcVideoRender();

  @override
  Future<NEResult<int>> createVideoRenderer(String roomUuid) =>
      _api.createVideoRenderer(roomUuid).then((value) =>
          NEResult(code: value.code, msg: value.msg, data: value.data1));

  @override
  Future<VoidResult> setMirror(int textureId, bool mirror) => _api
      .setMirror(textureId, mirror)
      .then((value) => VoidResult(code: value.code, msg: value.msg));

  @override
  Future<VoidResult> setupRemoteSubStreamVideoRenderer(
          String userUuid, int textureId) =>
      _api
          .setupRemoteSubStreamVideoRenderer(userUuid, textureId)
          .then((value) => VoidResult(code: value.code, msg: value.msg));

  @override
  Future<VoidResult> setupRemoteVideoRenderer(String userUuid, int textureId) =>
      _api
          .setupRemoteVideoRenderer(userUuid, textureId)
          .then((value) => VoidResult(code: value.code, msg: value.msg));

  @override
  Future<VoidResult> disposeVideoRenderer(int textureId) => _api
      .disposeVideoRenderer(textureId)
      .then((value) => VoidResult(code: value.code, msg: value.msg));

  @override
  Future<VoidResult> setupLocalVideoRenderer(int textureId) => _api
      .setupLocalVideoRenderer(textureId)
      .then((value) => VoidResult(code: value.code, msg: value.msg));

  @override
  Future<VoidResult> detachLocalVideoRenderer(bool subStream, int textureId) {
    return _api
        .detachLocalVideoRenderer(subStream, textureId)
        .then((value) => VoidResult(code: value.code, msg: value.msg));
  }

  @override
  Future<VoidResult> setupLocalSubStreamVideoRenderer(int textureId) async {
    return const NEResult(code: -1, msg: 'Not implemented');
  }

  @override
  Future<VoidResult> detachRemoteVideoRenderer(
      String userUuid, bool subStream, int textureId) {
    return _api
        .detachRemoteVideoRenderer(userUuid, subStream, textureId)
        .then((value) => VoidResult(code: value.code, msg: value.msg));
  }
}
