// Copyright (c) 2022 NetEase, Inc. All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.

import 'package:netease_common/netease_common.dart';
import 'package:netease_roomkit_interface/netease_roomkit_interface.dart';
import 'package:netease_roomkit_interface/src/pigeon.dart';

class MethodChannelWhiteboardController
    extends RoomWhiteboardControllerPlatform {
  final _api = RoomWhiteboardControllerApi();

  @override
  Future<VoidResult> startWhiteboardShare(String roomUuid) {
    return _api
        .startWhiteboardShare(roomUuid)
        .then((value) => VoidResult(code: value.code, msg: value.msg));
  }

  @override
  Future<VoidResult> stopWhiteboardShare(String roomUuid) {
    return _api
        .stopWhiteboardShare(roomUuid)
        .then((value) => VoidResult(code: value.code, msg: value.msg));
  }

  @override
  Future<VoidResult> setEnableDraw(String roomUuid, bool enable) {
    return _api
        .setEnableDraw(roomUuid, enable)
        .then((value) => VoidResult(code: value.code, msg: value.msg));
  }

  @override
  Future<VoidResult> stopMemberWhiteboardShare(
      String roomUuid, String userUuid) {
    return _api
        .stopMemberWhiteboardShare(roomUuid, userUuid)
        .then((value) => VoidResult(code: value.code, msg: value.msg));
  }

  @override
  Future<VoidResult> setCanvasBackgroundColor(String roomUuid, String color) {
    return _api
        .setCanvasBackgroundColor(roomUuid, color)
        .then((value) => VoidResult(code: value.code, msg: value.msg));
  }

  @override
  Future<VoidResult> lockCameraWithContent(
      String roomUuid, int width, int height) {
    return _api
        .lockCameraWithContent(roomUuid, width, height)
        .then((value) => VoidResult(code: value.code, msg: value.msg));
  }
}
