// Copyright (c) 2022 NetEase, Inc. All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.

import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import 'package:netease_common/netease_common.dart';
import 'package:netease_roomkit_interface/src/method_channel/method_channel_auth_service.dart';
import 'package:netease_roomkit_interface/src/types/auth_service_models.dart';

abstract class AuthServicePlatform extends PlatformInterface {
  static final Object _token = Object();

  AuthServicePlatform() : super(token: _token);

  static AuthServicePlatform _instance = MethodChannelAuthService();

  static AuthServicePlatform get instance => _instance;

  static set instance(AuthServicePlatform instance) {
    PlatformInterface.verify(instance, _token);
    _instance = instance;
  }

  Future<bool> get isLoggedIn;

  Stream<NEAuthEvent> get onAuthStatusChanged;

  Future<VoidResult> login(String account, String token);

  Future<VoidResult> logout();
}
