// Copyright (c) 2022 NetEase, Inc. All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.

import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import 'package:netease_common/netease_common.dart';
import 'package:netease_roomkit_interface/src/method_channel/method_channel_message_service.dart';
import 'package:netease_roomkit_interface/src/pigeon.dart';
import '../types/room_service_models.dart';

abstract class MessageChannelServicePlatform extends PlatformInterface {
  static final Object _token = Object();

  MessageChannelServicePlatform() : super(token: _token);

  static MessageChannelServicePlatform _instance =
      MethodChannelMessageService();

  static MessageChannelServicePlatform get instance => _instance;

  static set instance(MessageChannelServicePlatform instance) {
    PlatformInterface.verify(instance, _token);
    _instance = instance;
  }

  void addMessageListener(MessageEventSink sink);

  void removeMessageListener(MessageEventSink sink);

  Future<VoidResult> sendCustomMessage(
      String? roomUuid, String userUuid, int commandId, String data,
      {NEInjectedAuthorization? injectedAuthorization});
}
