// Copyright (c) 2022 NetEase, Inc. All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.

import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import 'package:netease_common/netease_common.dart';

import '../method_channel/method_channel_room_rtc_render.dart';

abstract class RoomRtcRenderPlatform extends PlatformInterface {
  static final Object _token = Object();

  RoomRtcRenderPlatform() : super(token: _token);

  static RoomRtcRenderPlatform _instance = MethodChannelRoomRtcRender();

  static RoomRtcRenderPlatform get instance => _instance;

  static set instance(RoomRtcRenderPlatform instance) {
    PlatformInterface.verify(instance, _token);
    _instance = instance;
  }

  Future<NEResult<int>> createVideoRenderer(String roomUuid);

  Future<VoidResult> setupLocalVideoRenderer(int textureId);

  Future<VoidResult> setupLocalSubStreamVideoRenderer(int textureId);

  Future<VoidResult> detachLocalVideoRenderer(bool subStream, int textureId);

  Future<VoidResult> detachRemoteVideoRenderer(
      String userUuid, bool subStream, int textureId);

  Future<VoidResult> setMirror(int textureId, bool mirror);

  Future<VoidResult> setupRemoteSubStreamVideoRenderer(
      String userUuid, int textureId);

  Future<VoidResult> setupRemoteVideoRenderer(String userUuid, int textureId);

  Future<VoidResult> disposeVideoRenderer(int textureId);
}
