// Copyright (c) 2022 NetEase, Inc. All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.

import 'package:netease_roomkit_interface/src/method_channel/method_channel_room_rtc_stats.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import 'package:netease_roomkit_interface/netease_roomkit_interface.dart';
// import 'package:netease_common/netease_common.dart';

abstract class RoomStatsPlatform extends PlatformInterface {
  static final Object _token = Object();

  RoomStatsPlatform() : super(token: _token);

  static RoomStatsPlatform _instance = MethodChannelRoomStats();

  static RoomStatsPlatform get instance => _instance;

  static set instance(RoomStatsPlatform instance) {
    PlatformInterface.verify(instance, _token);
    _instance = instance;
  }

  void registerStatsListener(String roomUuid, RoomStatsSink listener);

  void unregisterStatsListener(String roomUuid, RoomStatsSink listener);
}
