// Copyright (c) 2022 NetEase, Inc. All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.

import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import 'package:netease_common/netease_common.dart';
import 'package:netease_roomkit_interface/src/method_channel/method_channel_whiteboard_controller.dart';

abstract class RoomWhiteboardControllerPlatform extends PlatformInterface {
  static final Object _token = Object();

  RoomWhiteboardControllerPlatform() : super(token: _token);

  static RoomWhiteboardControllerPlatform _instance =
      MethodChannelWhiteboardController();

  static RoomWhiteboardControllerPlatform get instance => _instance;

  static set instance(RoomWhiteboardControllerPlatform instance) {
    PlatformInterface.verify(instance, _token);
    _instance = instance;
  }

  Future<VoidResult> startWhiteboardShare(String roomUuid);

  Future<VoidResult> stopWhiteboardShare(String roomUuid);

  Future<VoidResult> setEnableDraw(String roomUuid, bool enable);

  Future<VoidResult> stopMemberWhiteboardShare(
      String roomUuid, String userUuid);

  Future<VoidResult> lockCameraWithContent(
      String roomUuid, int width, int height);

  Future<VoidResult> setCanvasBackgroundColor(String roomUuid, String color);
}
