// Copyright (c) 2022 NetEase, Inc. All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.

import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import 'package:netease_roomkit_interface/src/method_channel/method_channel_roomkit.dart';
import 'package:netease_common/netease_common.dart';
import 'package:netease_roomkit_interface/src/pigeon.dart';
import 'package:netease_roomkit_interface/src/types/roomkit_options.dart';

abstract class RoomKitPlatform extends PlatformInterface {
  static final Object _token = Object();

  RoomKitPlatform() : super(token: _token);

  static RoomKitPlatform _instance = MethodChannelRoomKit();

  static RoomKitPlatform get instance => _instance;

  static set instance(RoomKitPlatform instance) {
    PlatformInterface.verify(instance, _token);
    _instance = instance;
  }

  /// 初始化
  Future<VoidResult> initialize(NERoomKitOptions options);

  Future<int> switchLanguage(String language);

  Future<NEResult<String?>> uploadLog();

  Future<dynamic> invokeMethod(String method,
      [Map<String, dynamic>? arguments]);

  Future<SDKVersions> get sdkVersions;

  Future<String> get deviceId;
}
