// Copyright (c) 2022 NetEase, Inc. All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.

/// 登录鉴权事件
enum NEAuthEvent {
  ///
  /// 被踢出登录
  ///
  kKickOut,

  ///
  /// Token过期
  ///
  kTokenExpired,

  ///
  /// Token不正确
  ///
  kIncorrectToken,

  ///
  /// 服务端禁止登录
  ///
  kForbidden,

  ///
  /// 账号或密码错误
  ///
  kAccountTokenError,

  ///
  /// 登录成功
  ///
  kLoggedIn,

  ///
  /// 未登录
  ///
  kLoggedOut,
}
