// Copyright (c) 2022 NetEase, Inc. All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.

///
/// 房间音频dump文件类型
///
enum NEChatroomMemberQueryType { kNormal, kOnlineNormal, kGuestDesc, kGuestAsc }

class NEChatroomMember {
  String? nick;
  String? avatar;

  NEChatroomMember({
    this.nick,
    this.avatar,
  });
}

enum NEChatroomMessageSearchOrder { kDesc, kAsc }

/// 聊天室消息 tag，默认内置等候室和聊天室
enum NEChatroomType {
  /// 主聊天室
  common,

  /// 等候室聊天室
  waitingRoom;
}

/// 查询聊天室历史消息选项
class NEChatroomHistoryMessageSearchOption {
  int startTime;
  int limit;
  NEChatroomMessageSearchOrder order;
  NEChatroomType chatroomType;

  NEChatroomHistoryMessageSearchOption({
    required this.startTime,
    required this.limit,
    this.order = NEChatroomMessageSearchOrder.kDesc,
    this.chatroomType = NEChatroomType.common,
  });
}
